private["_Entry","_cfgName","_index","_ConfPath","_y","_cnt","_lbParents"];

_ConfPath = _this select 0;

IPaths = [_ConfPath];

// Compile functions
_GetPData = compile preprocessFile "cfgexplorer\getpdata.sqf";

_cnt = count _ConfPath;

// Get some Dialog controls
_display = findDisplay 19000;
_ctrlPath = _display displayCtrl 2003;
_ctrlParent = _display displayCtrl 2010;
_lbClass = _display displayCtrl 1999;
_lbValues = _display displayCtrl 2000;
_lbParents = _display displayCtrl 2001;

// Display current/new path in upper Box
_ctrlPath ctrlSetStructuredText parseText format["%1",_ConfPath];

// Query if Inherits and show value in second box
_inherits = inheritsFrom _ConfPath;
if ((configName _inherits) == "") then {
	_inherits = "none";
};
_ctrlParent ctrlSetStructuredText parseText format["%1",_inherits];


// Handle Status of "UP"-Button
// Hide it, if we are in Root-Class
if (count paths == 1) then {
	// ctrlShow [2005, false];
	ctrlEnable [2005, false];
} else {
	// ctrlShow [2005, true];
	ctrlEnable [2005, true];
};


// Remove all Entrys
lbClear _lbClass ;
lbClear _lbValues ;
lbClear _lbParents;

// Clear Value array
_ValArray = [];
_ConfName = configName _ConfPath;

//
// Fill the listboxes
//
for "_y" from 0 to (_cnt - 1) do {	
	_Entry = (_ConfPath) select _y;
	
	_cfgName = configName _Entry;
	if (_confName == "bin\config.bin") then {
		_confName = "ROOT";
	};
	
	if (isClass _Entry) then { 
		//
		// Add Classinfo to left listbox
		//
		_index = lbAdd [1999, format["%1",_cfgName]];
		lbSetPicture [1999,_index,"CfgExplorer\icons\class.paa"];
		lbSetData [1999, _index, "Class"];
	} else {
		//
		// Add Valueinfos to right listbox
		//
		if (isNumber _Entry) then { 
			_text = format["(%1 ""%2""): %3   => %4",0,_ConfName,_cfgName,getNumber _Entry];
			_index = lbAdd [2000, _text];
			lbSetPicture [2000,_index,"CfgExplorer\icons\number.paa"];
			lbSetData [2000, _index, _cfgName];
			lbSetValue [2000, _index, 0];
			_ValArray  = _ValArray  + [_cfgName];
		};
		if (isText _Entry) then { 
			_text = format["(%1 ""%2""): %3   => ""%4""",0,_ConfName,_cfgName,gettext _Entry];
			_index = lbAdd [2000, _text];
			lbSetPicture [2000,_index,"CfgExplorer\icons\text.paa"];
			lbSetData [2000, _index, _cfgName];
			lbSetValue [2000, _index, 0];
			_ValArray  = _ValArray  + [_cfgName];
		};
		if (isArray _Entry) then { 
			_text = format["(%1 ""%2""): %3   => %4",0,_ConfName,_cfgName,getArray _Entry];
			_index = lbAdd [2000, _text];
			lbSetPicture [2000,_index,"CfgExplorer\icons\array.paa"];
			lbSetData [2000, _index, _cfgName];
			lbSetValue [2000, _index, 0];
			_ValArray  = _ValArray  + [_cfgName];
		};
	};
};
// Get the data from Parent Classes....
// Query if Inherits and show value in second box
_inherits = inheritsFrom _ConfPath;
if ((configName _inherits) == "") then {
	_inherits = "none";
} else {
	// Lets get data from Parent Class
	IPaths = IPaths + [_inherits];
	[_inherits,_ValArray,0] call _getpdata;
};
_ctrlParent ctrlSetStructuredText parseText format["%1",_inherits];

// Add values to leftdown listbox
for "_y" from 0 to ((count IPaths) -1 ) do {
	_text = format["(%1): %2",_y,configName (IPaths select _y)];
	_index = lbAdd [2001, _text];
};

// Sort the listboxes
lbSort _lbClass;
lbSort _lbvalues;

// Selection of right listbox to the first (if present)
lbSetCurSel [2000, 0];

// Query if Inherits and show value in second box
_inherits = inheritsFrom _ConfPath;
if ((configName _inherits) == "") then {
	_inherits = "none";
};
_ctrlParent ctrlSetStructuredText parseText format["%1",_inherits];
